<?php
/* Autor...:  */
/* Esquema.: ALM_Lote.xml */
/* Generado: 2021-11-07 23:55:52 */

/* Metodos de acceso a los campos de la tabla ALM_Lote */
abstract class BaseALM_LoteBN
{
    /* Campos de la tabla */
    private $i_IdLote;    // IdLote: ( no definido )
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $i_IdSucursal;    // IdSucursal: ( no definido )
    private $s_IdItem;    // IdItem: ( no definido )
    private $s_ProductoDescripcion;    // ProductoDescripcion: ( no definido )
    private $s_LoteNumero;    // LoteNumero: ( no definido )
    private $d_FechaVencimiento;    // FechaVencimiento: ( no definido )
    private $d_FechaOrigen;    // FechaOrigen: ( no definido )
    private $s_Descripcion;    // Descripcion: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $i_ProveedorId;    // ProveedorId: ( no definido )
    private $s_ProveedorNombre;    // ProveedorNombre: ( no definido )
    private $s_LoteNumeroProveedor;    // LoteNumeroProveedor: ( no definido )
    private $s_Anio;    // Anio: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdLote */
    public function setIdLote( $i_IdLote )
    {
        $this->i_IdLote = $i_IdLote;
    }

    /* Obtiene el valor del campo IdLote */
    public function getIdLote()
    {
        return $this->i_IdLote;
    }

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo IdSucursal */
    public function setIdSucursal( $i_IdSucursal )
    {
        $this->i_IdSucursal = $i_IdSucursal;
    }

    /* Obtiene el valor del campo IdSucursal */
    public function getIdSucursal()
    {
        return $this->i_IdSucursal;
    }

    /* Establece el valor del campo IdItem */
    public function setIdItem( $s_IdItem )
    {
        $this->s_IdItem = $s_IdItem;
    }

    /* Obtiene el valor del campo IdItem */
    public function getIdItem()
    {
        return $this->s_IdItem;
    }

    /* Establece el valor del campo ProductoDescripcion */
    public function setProductoDescripcion( $s_ProductoDescripcion )
    {
        $this->s_ProductoDescripcion = $s_ProductoDescripcion;
    }

    /* Obtiene el valor del campo ProductoDescripcion */
    public function getProductoDescripcion()
    {
        return $this->s_ProductoDescripcion;
    }

    /* Establece el valor del campo LoteNumero */
    public function setLoteNumero( $s_LoteNumero )
    {
        $this->s_LoteNumero = $s_LoteNumero;
    }

    /* Obtiene el valor del campo LoteNumero */
    public function getLoteNumero()
    {
        return $this->s_LoteNumero;
    }

    /* Establece el valor del campo FechaVencimiento */
    public function setFechaVencimiento( $d_FechaVencimiento )
    {
        $this->d_FechaVencimiento = $d_FechaVencimiento;
    }

    /* Obtiene el valor del campo FechaVencimiento */
    public function getFechaVencimiento()
    {
        return $this->d_FechaVencimiento;
    }

    /* Establece el valor del campo FechaOrigen */
    public function setFechaOrigen( $d_FechaOrigen )
    {
        $this->d_FechaOrigen = $d_FechaOrigen;
    }

    /* Obtiene el valor del campo FechaOrigen */
    public function getFechaOrigen()
    {
        return $this->d_FechaOrigen;
    }

    /* Establece el valor del campo Descripcion */
    public function setDescripcion( $s_Descripcion )
    {
        $this->s_Descripcion = $s_Descripcion;
    }

    /* Obtiene el valor del campo Descripcion */
    public function getDescripcion()
    {
        return $this->s_Descripcion;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo ProveedorId */
    public function setProveedorId( $i_ProveedorId )
    {
        $this->i_ProveedorId = $i_ProveedorId;
    }

    /* Obtiene el valor del campo ProveedorId */
    public function getProveedorId()
    {
        return $this->i_ProveedorId;
    }

    /* Establece el valor del campo ProveedorNombre */
    public function setProveedorNombre( $s_ProveedorNombre )
    {
        $this->s_ProveedorNombre = $s_ProveedorNombre;
    }

    /* Obtiene el valor del campo ProveedorNombre */
    public function getProveedorNombre()
    {
        return $this->s_ProveedorNombre;
    }

    /* Establece el valor del campo LoteNumeroProveedor */
    public function setLoteNumeroProveedor( $s_LoteNumeroProveedor )
    {
        $this->s_LoteNumeroProveedor = $s_LoteNumeroProveedor;
    }

    /* Obtiene el valor del campo LoteNumeroProveedor */
    public function getLoteNumeroProveedor()
    {
        return $this->s_LoteNumeroProveedor;
    }

    /* Establece el valor del campo Anio */
    public function setAnio( $s_Anio )
    {
        $this->s_Anio = $s_Anio;
    }

    /* Obtiene el valor del campo Anio */
    public function getAnio()
    {
        return $this->s_Anio;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdLote' => $this->getIdLote(),
            'IdCompania' => $this->getIdCompania(),
            'IdSucursal' => $this->getIdSucursal(),
            'IdItem' => $this->getIdItem(),
            'ProductoDescripcion' => $this->getProductoDescripcion(),
            'LoteNumero' => $this->getLoteNumero(),
            'FechaVencimiento' => $this->getFechaVencimiento(),
            'FechaOrigen' => $this->getFechaOrigen(),
            'Descripcion' => $this->getDescripcion(),
            'Estado' => $this->getEstado(),
            'ProveedorId' => $this->getProveedorId(),
            'ProveedorNombre' => $this->getProveedorNombre(),
            'LoteNumeroProveedor' => $this->getLoteNumeroProveedor(),
            'Anio' => $this->getAnio(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto ALM_LoteBN desde un RecordSet */
    public static function retrieveByRs( $o_ALM_LoteRs )
    {
        $o_ALM_LoteBN = new ALM_LoteBN();
        $o_ALM_LoteBN->setIdLote( ( integer ) $o_ALM_LoteRs[ "IdLote" ] );
        $o_ALM_LoteBN->setIdCompania( ( integer ) $o_ALM_LoteRs[ "IdCompania" ] );
        $o_ALM_LoteBN->setIdSucursal( ( integer ) $o_ALM_LoteRs[ "IdSucursal" ] );
        $o_ALM_LoteBN->setIdItem( $o_ALM_LoteRs[ "IdItem" ] );
        $o_ALM_LoteBN->setProductoDescripcion( $o_ALM_LoteRs[ "ProductoDescripcion" ] );
        $o_ALM_LoteBN->setLoteNumero( $o_ALM_LoteRs[ "LoteNumero" ] );
        $o_ALM_LoteBN->setFechaVencimiento( utilTimestamp::getTimestamp( $o_ALM_LoteRs[ "FechaVencimiento" ], "Y-m-d" ) );
        $o_ALM_LoteBN->setFechaOrigen( utilTimestamp::getTimestamp( $o_ALM_LoteRs[ "FechaOrigen" ], "Y-m-d" ) );
        $o_ALM_LoteBN->setDescripcion( $o_ALM_LoteRs[ "Descripcion" ] );
        $o_ALM_LoteBN->setEstado( $o_ALM_LoteRs[ "Estado" ] );
        $o_ALM_LoteBN->setProveedorId( ( integer ) $o_ALM_LoteRs[ "ProveedorId" ] );
        $o_ALM_LoteBN->setProveedorNombre( $o_ALM_LoteRs[ "ProveedorNombre" ] );
        $o_ALM_LoteBN->setLoteNumeroProveedor( $o_ALM_LoteRs[ "LoteNumeroProveedor" ] );
        $o_ALM_LoteBN->setAnio( $o_ALM_LoteRs[ "Anio" ] );
        $o_ALM_LoteBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_ALM_LoteRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_ALM_LoteBN->setUsuarioCreacion( $o_ALM_LoteRs[ "UsuarioCreacion" ] );
        $o_ALM_LoteBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_ALM_LoteRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_ALM_LoteBN->setUsuarioModificacion( $o_ALM_LoteRs[ "UsuarioModificacion" ] );
        return $o_ALM_LoteBN;
    }
}
?>